//
//  FGHudLevelIndicatorCell.h
//  FGBseHUD
//
//  Created by Francesco on 2/17/06.
//
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////
#import <Cocoa/Cocoa.h>
#import "FGHUDView.h"

@interface FGHudLevelIndicatorCell : NSLevelIndicatorCell {
    NSColor *aFillColor;
    NSColor *aBorderColor;

    NSColor *aFillColorWarning;
    NSColor *aFillColorCritical;

    int nType; //one of the FGLevelIndicatorStyle enum
	
    FGHUDView *aHudView;
    NSColor *foreColor;
    NSColor *backColor;
	
	 BOOL bUseGradient;      //TRUE uso gradiente
	 
	   NSString *theTitle;
	   
	    NSImage *aImageButton; //Normal ON

   NSTimer *aTimer;
   
   double nIncrement;
   NSTimeInterval nInterval;
   
   BOOL bEnableReverse;
   int nDirection; //0=left to right 1=right to left
    		
}
- (void) setUseGradient:(BOOL) bYesNo;
-(void) setFGLevelIndicatorStyle:(FGLevelIndicatorStyle)levelIndicatorStyle; //imposto il tipo di indicatore
- (void) setFillColor:(NSColor*) aColor;
- (void) setFillColorWarning:(NSColor*) aColor;
- (void) setFillColorCritical:(NSColor*) aColor;
- (void) setColorBorder:(NSColor*) aColor;
-(void) setTitle:(NSString *) aString; //Imposto il titolo
- (void) seImageForBarLeds:(NSImage *)imageNormal;
-(void) startAnimation:(NSTimeInterval)inteval withIncrement:(double)increment;
-(void) stopAnimation;
- (void) setEnableReverse:(BOOL) bYesNo;

//Internal use
- (void)stepItFireMethod:(NSTimer*)theTimer;
-(void) drawText:(NSRect)cellFrame; //scrive il testo del titolo nel pulsante 
@end
