//
//  FGHudPopUpCell.m
//  FGBseHUD
//
//  Created by Francesco on 2/18/06.
//
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////

#import "FGHudPopUpCell.h"
#import "FGNSBezierPathAddition.h"


@implementation FGHudPopUpCell

- (id)init{
    self = [super init];
    if (self) {
     aImageButton=[[NSImage  imageNamed:@"samplebtn.tiff"] retain];
    }
    return self;
}

-(void) dealloc {
    [aImageButton release];
	[super dealloc];
}


- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
  
  NSRect rcInvalidate= [[self controlView] bounds];
  aHudView=(FGHUDView *)[[super controlView] superview];
  foreColor=[aHudView clrTitleBar];
  backColor=[aHudView clrBodyBar];
  [backColor set];
  NSRectFill(rcInvalidate);
  
   [foreColor set];
   NSBezierPath *path = [NSBezierPath bezierPathWithRoundedRect:rcInvalidate cornerRadius:4];
   [path setFlatness:1.0];
   [path setLineWidth:1.0];
   [path fill];
   [[NSColor whiteColor] set];
   [NSBezierPath bezierPathWithRoundedRect:rcInvalidate cornerRadius:4];
   [path stroke];

   NSString* aLabel=[super titleOfSelectedItem];
  
  NSRect rcImagePos;
  NSPoint ptImagePos;
  rcImagePos=cellFrame;
 if(aImageButton!=nil){
  if(aLabel==nil)
   ptImagePos.x=rcImagePos.origin.x+(rcImagePos.size.width-[aImageButton size].width)/2;
  else
   ptImagePos.x=rcImagePos.origin.x+2;
   
  ptImagePos.y=rcImagePos.origin.y+(rcImagePos.size.height-[aImageButton size].height)/2;
  [aImageButton setFlipped:YES];
  [aImageButton drawAtPoint:ptImagePos fromRect:NSMakeRect(0,0,[aImageButton size].width,[aImageButton size].height) operation:NSCompositeSourceOver fraction:1.0];
  [aImageButton setFlipped:NO];

  rcImagePos.origin.x+=[aImageButton size].width+2;
 }
 
 [self drawText:rcImagePos forLabel:aLabel];
}

 //scrive il testo 
- (void) drawText:(NSRect)cellFrame forLabel:(NSString*) theLabel{
 NSString *infoString = [NSString stringWithFormat:@"<span style=\"font-size: 10px; font-family: 'Lucida Grande'; color: #FFFFFF;\"><strong>%@</strong></span>",theLabel];
 NSAttributedString * attributedInfoString = [[NSAttributedString alloc] initWithHTML:[infoString dataUsingEncoding:NSASCIIStringEncoding] documentAttributes:NULL];
 NSPoint stringPoint;
 stringPoint.x =  cellFrame.origin.x+4;
 stringPoint.y =  cellFrame.origin.y+ (cellFrame.size.height-[attributedInfoString size].height)/2;
 [attributedInfoString drawAtPoint:stringPoint];
 [attributedInfoString release];
}


- (BOOL) trackMouse: (NSEvent *) event
	     inRect: (NSRect) cellFrame
	     ofView: (NSView *) controlView
       untilMouseUp: (BOOL) untilMouseUp
{
    BOOL trackingResult = YES;
    
 	//NSPoint mouseLocation = [controlView convertPoint: [event locationInWindow]  fromView: nil];

	if ([event type] == NSLeftMouseDown )
	{
	    NSEvent *newEvent = [NSEvent mouseEventWithType: [event type]
						   location: NSMakePoint([controlView frame].origin.x+8, [controlView frame].origin.y + 3)
					      modifierFlags: [event modifierFlags]
						  timestamp: [event timestamp]
					       windowNumber: [event windowNumber]
						    context: [event context]
						eventNumber: [event eventNumber]
						 clickCount: [event clickCount]
						   pressure: [event pressure]];
						   
		NSMenu *aMenu=[self menu];		
		int nItems=[aMenu numberOfItems];
		int nIndex=0;
		NSMenuItem *aItemMenu=nil;
		for(nIndex=0;nIndex<nItems;nIndex++){
		 aItemMenu=[aMenu itemAtIndex:nIndex];
		 [self replaceItem:aItemMenu];
		}
		[NSMenu popUpContextMenu: [self menu]  withEvent: newEvent  forView: controlView];
	}
	else
	{
	    trackingResult = [self trackMouse: event
					      inRect: cellFrame
					      ofView: controlView
					untilMouseUp: [[self class] prefersTrackingUntilMouseUp]];  // NO for NSButton
	    
	    if (trackingResult == YES)
	    {
		 NSMenuItem *selectedItem = [self selectedItem];
		 [[NSApplication sharedApplication] sendAction: [selectedItem action]  to: [selectedItem target]  from: selectedItem];
	    }
	}
    
    NSLog(@"trackingResult: %d", trackingResult);
    
    return trackingResult;
}

-(void) replaceItem:(NSMenuItem*) mnuItem{
  NSString *aTitle=[mnuItem title];
  NSString *infoString = [NSString stringWithFormat:@"<span style=\"font-size: 10px; font-family: 'Lucida Grande'; color: #0023ba;\"><strong>%@</strong></span>",aTitle];
  NSAttributedString * attributedInfoString = [[NSAttributedString alloc] initWithHTML:[infoString dataUsingEncoding:NSASCIIStringEncoding] documentAttributes:NULL];
  [mnuItem setAttributedTitle:attributedInfoString];
}

@end
